import numpy as np


def cicParticles(particles, L, N):


    def shifted(i, t):
      return (i[2]+t[2])%N + N*((i[1]+t[1])%N + N*((i[0]+t[0])%N))

    i =[]
    r = []
    for d in xrange(3):
        q = (particles[d]%L)*N/L
        o = np.floor(q).astype(int)
        i.append(o)
        r.append(q-o)
    
    density  = np.bincount(shifted(i, (1,1,1)), weights=   r[0] *   r[1] *   r[2], minlength=N*N*N)
    density += np.bincount(shifted(i, (1,1,0)), weights=   r[0] *   r[1] *(1-r[2]), minlength=N*N*N)
    density += np.bincount(shifted(i, (1,0,1)), weights=   r[0] *(1-r[1])*   r[2], minlength=N*N*N)
    density += np.bincount(shifted(i, (1,0,0)), weights=   r[0] *(1-r[1])*(1-r[2]), minlength=N*N*N)
    density += np.bincount(shifted(i, (0,1,1)), weights=(1-r[0])*   r[1] *   r[2], minlength=N*N*N)
    density += np.bincount(shifted(i, (0,1,0)), weights=(1-r[0])*   r[1] *(1-r[2]), minlength=N*N*N)
    density += np.bincount(shifted(i, (0,0,1)), weights=(1-r[0])*(1-r[1])*   r[2], minlength=N*N*N)
    density += np.bincount(shifted(i, (0,0,0)), weights=(1-r[0])*(1-r[1])*(1-r[2]), minlength=N*N*N)

    return density.reshape((N,N,N))
